Index: trunk/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComSlice.cpp	(revision 1180)
+++ trunk/source/Lib/TLibCommon/TComSlice.cpp	(revision 1196)
@@ -137,19 +137,10 @@
 #endif
 #if H_3D
-#if HHI_INTER_COMP_PRED_K0052
 , m_inCmpPredFlag                 ( false )
-#endif
-#if HHI_CAM_PARA_K0052
 , m_numViews                        ( 0    )
-#endif
 , m_depthToDisparityB             ( NULL )
 , m_depthToDisparityF             ( NULL )
-#endif
-#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+
 , m_bApplyDIS                     (false)
-#else
-#if H_3D_SINGLE_DEPTH
-, m_bApplySingleDepthMode         (false)
-#endif
 #endif
 #endif
@@ -191,5 +182,5 @@
   m_iDefaultRefViewIdx = -1;
   m_bDefaultRefViewIdxAvailableFlag = false;
-#if HHI_INTER_COMP_PRED_K0052
+#if H_3D
   m_ivMvPredFlag           = false;
   m_ivMvScalingFlag        = false;
@@ -214,9 +205,5 @@
   m_puiSubstreamSizes = NULL;
 #if H_3D
-#if HHI_CAM_PARA_K0052   
   for( UInt i = 0; i < m_numViews; i++ )
-#else
-  for( UInt i = 0; i < getViewIndex(); i++ )
-#endif
   {
     if ( m_depthToDisparityB && m_depthToDisparityB[ i ] )
@@ -604,9 +591,7 @@
   UInt NumPocLtCurr = 0;
   Int i;
-
-#if HHI_RES_PRED_K0052
+#if H_3D
   m_pocsInCurrRPSs.clear();
 #endif
-
   for(i=0; i < m_pcRPS->getNumberOfNegativePictures(); i++)
   {
@@ -619,5 +604,5 @@
       NumPocStCurr0++;
       pcRefPic->setCheckLTMSBPresent(false);  
-#if HHI_RES_PRED_K0052
+#if H_3D
       m_pocsInCurrRPSs.push_back( pcRefPic->getPOC() ); 
 #endif
@@ -635,5 +620,5 @@
       NumPocStCurr1++;
       pcRefPic->setCheckLTMSBPresent(false);  
-#if HHI_RES_PRED_K0052
+#if H_3D
       m_pocsInCurrRPSs.push_back( pcRefPic->getPOC() ); 
 #endif
@@ -650,5 +635,5 @@
       RefPicSetLtCurr[NumPocLtCurr] = pcRefPic;
       NumPocLtCurr++;
-#if HHI_RES_PRED_K0052
+#if H_3D
       m_pocsInCurrRPSs.push_back( pcRefPic->getPOC() ); 
 #endif
@@ -662,5 +647,5 @@
 
   Int numPocInterCurr = NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr; 
-#if HHI_RES_PRED_K0052
+#if H_3D
   assert( numPocInterCurr == (Int) m_pocsInCurrRPSs.size() ); 
 #endif
@@ -837,5 +822,4 @@
 Void TComSlice::setCamparaSlice( Int** aaiScale, Int** aaiOffset )
 {  
-#if HHI_CAM_PARA_K0052
   Int voiInVps      = m_pcVPS->getVoiInVps(getViewIndex() ); 
   if( m_pcVPS->getNumCp( voiInVps ) > 0 )
@@ -855,16 +839,4 @@
     }
   } 
-#else
-  if( m_pcVPS->hasCamParInSliceHeader( m_viewIndex ) )
-  {    
-    for( UInt uiBaseViewIndex = 0; uiBaseViewIndex < m_viewIndex; uiBaseViewIndex++ )
-    {
-      m_aaiCodedScale [ 0 ][ uiBaseViewIndex ] = aaiScale [ uiBaseViewIndex ][     m_viewIndex ];
-      m_aaiCodedScale [ 1 ][ uiBaseViewIndex ] = aaiScale [     m_viewIndex ][ uiBaseViewIndex ];
-      m_aaiCodedOffset[ 0 ][ uiBaseViewIndex ] = aaiOffset[ uiBaseViewIndex ][     m_viewIndex ];
-      m_aaiCodedOffset[ 1 ][ uiBaseViewIndex ] = aaiOffset[     m_viewIndex ][ uiBaseViewIndex ];
-    }
-  } 
-#endif
 }
 #endif
@@ -1165,10 +1137,6 @@
   }
 #endif
-#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+#if H_3D
   m_bApplyDIS = pSrc->m_bApplyDIS;
-#else
-#if H_3D_SINGLE_DEPTH
-  m_bApplySingleDepthMode = pSrc->m_bApplySingleDepthMode;
-#endif
 #endif
 #if H_3D_IC
@@ -2217,5 +2185,4 @@
 {
   m_numViews = 1; 
-#if HHI_VIEW_ID_LIST_I5_J0107 || HHI_INTER_COMP_PRED_K0052
 #if H_3D
   AOF( m_viewOIdxList.size() == 0 ); 
@@ -2223,5 +2190,4 @@
   m_viewOIdxList.push_back( 0 );        
 #endif
-#endif
 
   for( Int i = 0; i <=  getMaxLayersMinus1(); i++ )
@@ -2241,9 +2207,7 @@
       {
         m_numViews++;
-#if HHI_VIEW_ID_LIST_I5_J0107  || HHI_INTER_COMP_PRED_K0052
 #if H_3D
         m_viewOIdxList.push_back( getViewOrderIdx( lId ) );        
 #endif
-#endif
       }
     }
@@ -2271,7 +2235,4 @@
     }
   }
-#if !BUG_FIX_TK65
-  assert( foundLayerIdinNuh != -1 ); 
-#endif
   return foundLayerIdinNuh;
 }
@@ -2281,5 +2242,4 @@
   Int i = 0, j = 0;
 
-#if HHI_CAM_PARA_K0052
   m_numCp    = new Int [ iNumViews ];
   m_cpRefVoi = new Int*[ iNumViews ];
@@ -2287,8 +2247,4 @@
 
   m_cpPresentFlag  = new Bool*[ iNumViews ]; 
-#else
-  m_bCamParPresent = new Bool[ iNumViews ];
-  m_bCamParInSliceHeader = new Bool[ iNumViews ];
-#endif
   
 
@@ -2297,15 +2253,9 @@
   for ( i = 0; i < iNumViews ; i++ )
   {
-#if HHI_CAM_PARA_K0052
     m_cpInSliceSegmentHeaderFlag[i] = false;     
-#else
-    m_bCamParPresent[i] = false; 
-    m_bCamParInSliceHeader[i] = false; 
-#endif
     
     m_aaaiCodedScale[i] = new Int*[ 2 ];
     m_aaaiCodedOffset[i] = new Int*[ 2 ];
 
-#if HHI_CAM_PARA_K0052
     m_numCp   [i] = 0; 
     m_cpRefVoi[i] = new Int[ iNumViews ];
@@ -2316,5 +2266,4 @@
       m_cpPresentFlag[i][j] = false; 
     }
-#endif
     for ( j = 0; j < 2; j++ )
     {
@@ -2335,14 +2284,4 @@
   Int i = 0, j = 0;
 
-#if !HHI_CAM_PARA_K0052
-  if ( m_bCamParPresent != NULL )
-  {
-    delete [] m_bCamParPresent;
-  }
-  if ( m_bCamParInSliceHeader != NULL )
-  {
-    delete [] m_bCamParInSliceHeader;
-  }
-#else
   if ( m_numCp != NULL )
   {
@@ -2373,5 +2312,4 @@
     delete [] m_cpInSliceSegmentHeaderFlag;
   }
-#endif
 
 
@@ -2404,25 +2342,4 @@
 
 
-#if !HHI_CAM_PARA_K0052
-Void TComVPS::initCamParaVPS( UInt uiViewIndex, Bool bCamParPresent, UInt uiCamParPrecision, Bool bCamParSlice, Int** aaiScale, Int** aaiOffset )
-{
-  AOT( uiViewIndex != 0 && !bCamParSlice && ( aaiScale == 0 || aaiOffset == 0 ) );  
-
-  m_uiCamParPrecision = ( ( uiViewIndex != 0 )? uiCamParPrecision : 0 );
-  m_bCamParPresent[ uiViewIndex ] = (( uiViewIndex != 0 )? bCamParPresent  : false );
-  m_bCamParInSliceHeader[ uiViewIndex ]  = ( (uiViewIndex != 0)? bCamParSlice  : false );
-
-  if( !m_bCamParInSliceHeader[ uiViewIndex ] )
-  {
-    for( UInt uiBaseViewIndex = 0; uiBaseViewIndex < uiViewIndex; uiBaseViewIndex++ )
-    {
-      m_aaaiCodedScale [ uiViewIndex ][ 0 ][ uiBaseViewIndex ] = aaiScale [ uiBaseViewIndex ][     uiViewIndex ];
-      m_aaaiCodedScale [ uiViewIndex ][ 1 ][ uiBaseViewIndex ] = aaiScale [     uiViewIndex ][ uiBaseViewIndex ];
-      m_aaaiCodedOffset[ uiViewIndex ][ 0 ][ uiBaseViewIndex ] = aaiOffset[ uiBaseViewIndex ][     uiViewIndex ];
-      m_aaaiCodedOffset[ uiViewIndex ][ 1 ][ uiBaseViewIndex ] = aaiOffset[     uiViewIndex ][ uiBaseViewIndex ];
-    }
-  }
-}
-#endif
 
 #endif // H_3D
@@ -2804,4 +2721,65 @@
 }
 
+#if H_3D
+Void TComVPS::initViewCompLayer()
+{
+  assert( m_viewCompLayerId.size() == 0 && m_viewCompLayerPresentFlag.size() == 0  );
+  for( Int i = 0; i < getNumViews(); i++ )
+  {
+    m_viewCompLayerId         .push_back( std::vector<Int>(0)  );
+    m_viewCompLayerPresentFlag.push_back( std::vector<Bool>(0) );      
+
+    for( Int depFlag = 0; depFlag  <=  1; depFlag++ )
+    {
+      Int iViewOIdx = getViewOIdxList( i );
+      Int layerId = -1;
+      for( Int j = 0; j  <=  getMaxLayersMinus1(); j++ ) 
+      {
+        Int jNuhLId = getLayerIdInNuh( j );
+        if( getVpsDepthFlag( jNuhLId ) == ( (Bool) depFlag )  &&  getViewOrderIdx( jNuhLId )  ==  iViewOIdx  
+          &&  getDependencyId( jNuhLId )  ==  0  &&  getAuxId( jNuhLId )  ==  0 )
+        {
+          layerId = jNuhLId;
+        }
+      }
+      m_viewCompLayerPresentFlag[ i ].push_back( layerId  !=  -1 );
+      m_viewCompLayerId         [ i ].push_back( layerId );        
+    }
+  }
+}
+
+Int TComVPS::getVoiInVps(Int viewOIdx)
+{
+  for ( Int i = 0; i < m_viewOIdxList.size(); i++ )
+  {
+    if  ( m_viewOIdxList[ i ] == viewOIdx )
+    {
+      return i; 
+    }
+  }
+  assert( 0 );   
+  return -1;
+}
+
+Void TComVPS::deriveCpPresentFlag()
+{
+  for( Int nInVps = 0; nInVps < getNumViews(); nInVps++  )
+  {
+    for( Int mInVps = 0; mInVps < getNumViews(); mInVps++ )
+    {
+      m_cpPresentFlag[nInVps][mInVps] = 0; 
+    }
+  }
+
+  for( Int n = 1; n < getNumViews(); n++ )
+  {
+    Int iInVps = getVoiInVps(  getViewOIdxList( n ) );      
+    for( Int m = 0; m < getNumCp( iInVps ); m++ )
+    {
+      m_cpPresentFlag[ iInVps ][ getVoiInVps( getCpRefVoi( iInVps, m ) ) ] = 1;
+    }
+  }
+}
+#endif
 
 #endif // H_MV
@@ -2858,9 +2836,4 @@
 , m_interViewMvVertConstraintFlag (false)
 #endif
-#if H_3D
-#if !HHI_CAM_PARA_K0052
-, m_bCamParInSliceHeader      (false)
-#endif
-#endif
 {
   for ( Int i = 0; i < MAX_TLAYER; i++ )
@@ -3885,5 +3858,5 @@
       {
         Int layerIdInNuh = getRefPicLayerId( i );
-#if HHI_RES_PRED_K0052
+
         TComPic* picV = getIvPic( getIsDepth(), getVPS()->getViewIndex( layerIdInNuh ) );
         assert( picV != NULL ); 
@@ -3900,9 +3873,4 @@
 
         if (getFirstTRefIdx(eRefPicList) >= 0 && refRpRefAvailFlag )
-#else
-        Int viewIdx = getVPS()->getViewId( layerIdInNuh );
-        TComPic*pcPicPrev = ivPicLists->getPic(viewIdx, 0, prevPOC);
-        if (getFirstTRefIdx(eRefPicList) >= 0 && pcPicPrev && pcPicPrev->getSlice( 0 )->isReferenced())
-#endif
         {
           m_arpRefPicAvailable[eRefPicList][layerIdInNuh] = true;
@@ -3917,5 +3885,7 @@
 }
 #endif
+
 #if H_3D_IC
+// This is an encoder only function and should be moved to TEncSlice or TEncSearch!!
 Void TComSlice::xSetApplyIC(Bool bUseLowLatencyICEnc)
 {
@@ -3981,78 +3951,75 @@
   }
   else
-  {
-  Int iMaxPelValue = ( 1 << g_bitDepthY ); 
-  Int *aiRefOrgHist;
-  Int *aiCurrHist;
-  aiRefOrgHist = (Int *) xMalloc( Int,iMaxPelValue );
-  aiCurrHist   = (Int *) xMalloc( Int,iMaxPelValue );
-  memset( aiRefOrgHist, 0, iMaxPelValue*sizeof(Int) );
-  memset( aiCurrHist, 0, iMaxPelValue*sizeof(Int) );
-  // Reference Idx Number
-  Int iNumRefIdx = getNumRefIdx( REF_PIC_LIST_0 );
-  TComPic* pcCurrPic = NULL;
-  TComPic* pcRefPic = NULL;
-  TComPicYuv* pcCurrPicYuv = NULL;
-  TComPicYuv* pcRefPicYuvOrg = NULL;
-  pcCurrPic = getPic();
-  pcCurrPicYuv = pcCurrPic->getPicYuvOrg();
-  Int iWidth = pcCurrPicYuv->getWidth();
-  Int iHeight = pcCurrPicYuv->getHeight();
-
-
-  // Get InterView Reference picture
-  // !!!!! Assume only one Interview Reference Picture in L0
-  for ( Int i = 0; i < iNumRefIdx; i++ )
-  {
-    pcRefPic = getRefPic( REF_PIC_LIST_0, i );
-    if ( pcRefPic != NULL )
-    {
-      if ( pcCurrPic->getViewIndex() != pcRefPic->getViewIndex() )
-      {
-        pcRefPicYuvOrg = pcRefPic->getPicYuvOrg();
-      }
-    }
-  }
-
-  if ( pcRefPicYuvOrg != NULL )
-  {
-    Pel* pCurrY = pcCurrPicYuv ->getLumaAddr();
-    Pel* pRefOrgY = pcRefPicYuvOrg  ->getLumaAddr();
-    Int iCurrStride = pcCurrPicYuv->getStride();
-    Int iRefStride = pcRefPicYuvOrg->getStride();
-    Int iSumOrgSAD = 0;
-    Double dThresholdOrgSAD = getIsDepth() ? 0.1 : 0.05;
-
-    // Histogram building - luminance
-    for ( Int y = 0; y < iHeight; y++ )
-    {
-      for ( Int x = 0; x < iWidth; x++ )
-      {
-        aiCurrHist[pCurrY[x]]++;
-        aiRefOrgHist[pRefOrgY[x]]++;
-      }
-      pCurrY += iCurrStride;
-      pRefOrgY += iRefStride;
-    }
-    // Histogram SAD
-    for ( Int i = 0; i < iMaxPelValue; i++ )
-    {
-      iSumOrgSAD += abs( aiCurrHist[i] - aiRefOrgHist[i] );
-    }
-    // Setting
-    if ( iSumOrgSAD > Int( dThresholdOrgSAD * iWidth * iHeight ) )
-    {
-      m_bApplyIC = true;
-    }
-    else
-    {
-      m_bApplyIC = false;
-    }
-  }
-
-  xFree( aiCurrHist   );
-  xFree( aiRefOrgHist );
-  aiCurrHist = NULL;
-  aiRefOrgHist = NULL;
+  {        
+    TComPic*    pcCurrPic = getPic();
+    TComPicYuv* pcCurrPicYuv = pcCurrPic->getPicYuvOrg();
+    
+    // Get InterView Reference picture
+    // !!!!! Assume only one Interview Reference Picture in L0
+    // GT: Is this assumption correct?
+
+    TComPicYuv* pcRefPicYuvOrg = NULL;
+    for ( Int i = 0; i < getNumRefIdx( REF_PIC_LIST_0 ); i++ )
+    {
+      TComPic* pcRefPic = getRefPic( REF_PIC_LIST_0, i );
+      if ( pcRefPic != NULL )
+      {
+        if ( pcCurrPic->getViewIndex() != pcRefPic->getViewIndex() )
+        {
+          pcRefPicYuvOrg = pcRefPic->getPicYuvOrg();
+        }
+      }
+    }
+
+    if ( pcRefPicYuvOrg != NULL )
+    {
+      // Histogram building - luminance
+      Int iMaxPelValue = ( 1 << g_bitDepthY ); 
+      Int *aiRefOrgHist = (Int *) xMalloc( Int,iMaxPelValue );
+      Int *aiCurrHist   = (Int *) xMalloc( Int,iMaxPelValue );
+      memset( aiRefOrgHist, 0, iMaxPelValue*sizeof(Int) );
+      memset( aiCurrHist, 0, iMaxPelValue*sizeof(Int) );
+
+      Int iWidth   = pcCurrPicYuv->getWidth();
+      Int iHeight  = pcCurrPicYuv->getHeight();
+
+      Pel* pCurrY   = pcCurrPicYuv ->getLumaAddr();
+      Pel* pRefOrgY = pcRefPicYuvOrg  ->getLumaAddr();
+      Int iCurrStride = pcCurrPicYuv->getStride();
+      Int iRefStride = pcRefPicYuvOrg->getStride();
+
+      for ( Int y = 0; y < iHeight; y++ )
+      {
+        for ( Int x = 0; x < iWidth; x++ )
+        {
+          aiCurrHist[pCurrY[x]]++;
+          aiRefOrgHist[pRefOrgY[x]]++;
+        }
+        pCurrY += iCurrStride;
+        pRefOrgY += iRefStride;
+      }
+
+      // Histogram SAD
+      Int iSumOrgSAD = 0;
+      for ( Int i = 0; i < iMaxPelValue; i++ )
+      {
+        iSumOrgSAD += abs( aiCurrHist[i] - aiRefOrgHist[i] );
+      }
+
+      // Setting
+      Double dThresholdOrgSAD = getIsDepth() ? 0.1 : 0.05;
+
+      if ( iSumOrgSAD > Int( dThresholdOrgSAD * iWidth * iHeight ) )
+      {
+        m_bApplyIC = true;
+      }
+      else
+      {
+        m_bApplyIC = false;
+      }
+
+      xFree( aiCurrHist   );
+      xFree( aiRefOrgHist );
+    }
   }//if(bUseLowLatencyICEnc)
 }
@@ -4087,17 +4054,10 @@
     return; 
 
-#if HHI_CAM_PARA_K0052
   m_numViews = getVPS()->getNumViews(); 
-#endif
   /// GT: Allocation should be moved to a better place later; 
   if ( m_depthToDisparityB == NULL )
   {
-#if HHI_CAM_PARA_K0052    
     m_depthToDisparityB = new Int*[ m_numViews ];
     for ( Int i = 0; i < getVPS()->getNumViews(); i++ )
-#else
-    m_depthToDisparityB = new Int*[ getViewIndex() ];
-    for ( Int i = 0; i < getViewIndex(); i++ )
-#endif
     {
       m_depthToDisparityB[ i ] = new Int[ Int(1 << g_bitDepthY) ]; 
@@ -4108,11 +4068,6 @@
   if ( m_depthToDisparityF == NULL )
   {
-#if HHI_CAM_PARA_K0052    
     m_depthToDisparityF = new Int*[ m_numViews ];
     for ( Int i = 0; i < m_numViews; i++ )
-#else
-    m_depthToDisparityF= new Int*[ getViewIndex() ];
-    for ( Int i = 0; i < getViewIndex(); i++ )
-#endif
     {
       m_depthToDisparityF[ i ] = new Int[ Int(1 << g_bitDepthY) ]; 
@@ -4125,5 +4080,4 @@
   TComVPS* vps = getVPS(); 
 
-#if HHI_CAM_PARA_K0052
   Int log2Div = g_bitDepthY - 1 + vps->getCpPrecision();
   Int voiInVps = vps->getVoiInVps( getViewIndex() ); 
@@ -4155,28 +4109,4 @@
     }
   }
-#else
-  Int log2Div = g_bitDepthY - 1 + vps->getCamParPrecision();
-
-  Int viewIndex = getViewIndex();
-
-  Bool camParaSH = vps->hasCamParInSliceHeader( viewIndex );
-
-  Int* codScale     = camParaSH ? m_aaiCodedScale [ 0 ] : vps->getCodedScale    ( viewIndex ); 
-  Int* codOffset    = camParaSH ? m_aaiCodedOffset[ 0 ] : vps->getCodedOffset   ( viewIndex ); 
-  Int* invCodScale  = camParaSH ? m_aaiCodedScale [ 1 ] : vps->getInvCodedScale ( viewIndex ); 
-  Int* invCodOffset = camParaSH ? m_aaiCodedOffset[ 1 ] : vps->getInvCodedOffset( viewIndex ); 
-
-  for (Int i = 0; i <= ( getViewIndex() - 1); i++)
-  {
-    for ( Int d = 0; d <= ( ( 1 << g_bitDepthY ) - 1 ); d++ )
-    {
-      Int offset =    ( codOffset  [ i ] << g_bitDepthY ) + ( ( 1 << log2Div ) >> 1 );         
-      m_depthToDisparityB[ i ][ d ] = ( codScale [ i ] * d + offset ) >> log2Div; 
-
-      Int invOffset = ( invCodOffset[ i ] << g_bitDepthY ) + ( ( 1 << log2Div ) >> 1 );         
-      m_depthToDisparityF[ i ][ d ] = ( invCodScale[ i ] * d + invOffset ) >> log2Div; 
-    }
-  }
-#endif
 }
 #endif
@@ -4222,76 +4152,4 @@
   Bool depthFlag = getIsDepth();
 
-#if !HHI_INTER_COMP_PRED_K0052
-  Bool depthOfRefViewsAvailFlag = false; 
-  Bool textOfCurViewAvailFlag = false; 
-
-  TComVPS* vps = getVPS(); 
-
-  if( !depthFlag )
-  {
-    depthOfRefViewsAvailFlag = true;
-    for( Int i = 0; i <= vps->getNumRefListLayers( getLayerId() ) - 1; i++)
-    {
-      Bool curDepthAvailableFlag = false;    
-      for (Int j = 0; j <= vps->getMaxLayersMinus1(); j++ )
-      {
-        if ( vps->getDirectDependencyFlag( vps->getLayerIdInVps( getLayerId() ), j )
-          && vps->getVpsDepthFlag        ( vps->getLayerIdInNuh( j ) ) == 1
-          && vps->getViewOrderIdx( vps->getLayerIdInNuh( j ) ) == vps->getViewOrderIdx( vps->getIdRefListLayer( getLayerId(), i ) )
-          && vps->getDependencyId( vps->getLayerIdInNuh( j ) ) == 0
-          && vps->getAuxId       ( vps->getLayerIdInNuh( j ) ) == 0
-          )
-        {
-          curDepthAvailableFlag = true; 
-        }
-      }
-      if ( !curDepthAvailableFlag )
-      {
-        depthOfRefViewsAvailFlag = false; 
-      }    
-    }
-  }
-  else
-  {
-    for (Int j = 0; j <= vps->getMaxLayersMinus1(); j++ )
-    {
-      if ( vps->getDirectDependencyFlag( vps->getLayerIdInVps( getLayerId() ), j ) 
-        && vps->getVpsDepthFlag( vps->getLayerIdInNuh( j ) ) == 0
-        && vps->getViewOrderIdx( vps->getLayerIdInNuh( j ) ) == getViewIndex() 
-        && vps->getDependencyId( vps->getLayerIdInNuh( j ) ) == 0
-        && vps->getAuxId       ( vps->getLayerIdInNuh( j ) ) == 0
-        )
-      {        
-        textOfCurViewAvailFlag = true; 
-      }
-    }
-  }
-
-
-  Bool lidG0  = ( getLayerId() > 0 );
-  Bool nRLLG0 =  ( getVPS()->getNumRefListLayers( getLayerId() ) > 0 );     
-
-  TComSps3dExtension* sps3dExt = getSPS()->getSps3dExtension();
-
-  m_ivMvPredFlag           = sps3dExt->getIvMvPredFlag         ( depthFlag ) && lidG0 && nRLLG0                           ;                             
-  m_ivMvScalingFlag        = sps3dExt->getIvMvScalingFlag      ( depthFlag ) && lidG0                                    ;                             
-  m_ivResPredFlag          = sps3dExt->getIvResPredFlag        ( depthFlag ) && lidG0 && nRLLG0                           ;                               
-  m_depthRefinementFlag    = sps3dExt->getDepthRefinementFlag  ( depthFlag ) && lidG0           && depthOfRefViewsAvailFlag;                            
-  m_viewSynthesisPredFlag  = sps3dExt->getViewSynthesisPredFlag( depthFlag ) && lidG0 && nRLLG0 && depthOfRefViewsAvailFlag;                          
-  m_depthBasedBlkPartFlag  = sps3dExt->getDepthBasedBlkPartFlag( depthFlag ) && lidG0           && depthOfRefViewsAvailFlag;                          
-  m_mpiFlag                = sps3dExt->getMpiFlag              ( depthFlag ) && lidG0           &&   textOfCurViewAvailFlag;
-  m_intraContourFlag       = sps3dExt->getIntraContourFlag     ( depthFlag ) && lidG0           &&   textOfCurViewAvailFlag;
-  m_intraSdcWedgeFlag      = sps3dExt->getIntraSdcWedgeFlag    ( depthFlag ) && lidG0                                     ;                          
-  m_qtPredFlag             = sps3dExt->getQtPredFlag           ( depthFlag ) && lidG0           &&   textOfCurViewAvailFlag;
-  m_interSdcFlag           = sps3dExt->getInterSdcFlag         ( depthFlag ) && lidG0                                    ;  
-#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
-  m_depthIntraSkipFlag     = sps3dExt->getDepthIntraSkipFlag   ( depthFlag ) && lidG0                                    ;                          
-#else
-  m_intraSingleFlag        = sps3dExt->getIntraSingleFlag      ( depthFlag ) && lidG0                                    ;                          
-#endif
-
-  m_subPbSize              = lidG0 ? ( 1 << ( sps3dExt->getLog2SubPbSizeMinus3   ( depthFlag ) + 3 ) ) : getSPS()->getMaxCUWidth();  
-  m_mpiSubPbSize           = 1 << ( sps3dExt->getLog2MpiSubPbSizeMinus3( depthFlag ) + 3 );
-#else
   Bool nRLLG0 =  ( getVPS()->getNumRefListLayers( getLayerId() ) > 0 );     
 
@@ -4301,11 +4159,6 @@
   m_ivMvScalingFlag        = sps3dExt->getIvMvScalingFlag      ( depthFlag )                                 ;                             
   m_ivResPredFlag          = sps3dExt->getIvResPredFlag        ( depthFlag ) && nRLLG0                       ;                               
-#if HHI_CAM_PARA_K0052
   m_depthRefinementFlag    = sps3dExt->getDepthRefinementFlag  ( depthFlag )           && getInCompPredFlag() && m_cpAvailableFlag;
   m_viewSynthesisPredFlag  = sps3dExt->getViewSynthesisPredFlag( depthFlag ) && nRLLG0 && getInCompPredFlag() && m_cpAvailableFlag;
-#else
-  m_depthRefinementFlag    = sps3dExt->getDepthRefinementFlag  ( depthFlag )           && getInCompPredFlag();                            
-  m_viewSynthesisPredFlag  = sps3dExt->getViewSynthesisPredFlag( depthFlag ) && nRLLG0 && getInCompPredFlag();                            
-#endif
   m_depthBasedBlkPartFlag  = sps3dExt->getDepthBasedBlkPartFlag( depthFlag )           && getInCompPredFlag();                          
   m_mpiFlag                = sps3dExt->getMpiFlag              ( depthFlag )           && getInCompPredFlag();
@@ -4319,5 +4172,4 @@
   m_mpiSubPbSize           =  1 << ( sps3dExt->getLog2MpiSubPbSizeMinus3( depthFlag ) + 3 );
 
-#endif
 
 #if H_3D_OUTPUT_ACTIVE_TOOLS
@@ -4325,12 +4177,6 @@
   std::cout << "DepthFlag:              :" << getIsDepth()             << std::endl;
   std::cout << "ViewOrderIdx:           :" << getViewIndex()           << std::endl;
-#if HHI_INTER_COMP_PRED_K0052
   std::cout << "InterCmpPredAvailableFlag:" << getInCmpPredAvailFlag() << std::endl;
   std::cout << "InterCompPredFlag       :"  << getInCompPredFlag()     << std::endl;
-  //std::cout << "TextOfCurViewAvailFlag  :" << textOfCurViewAvailFlag   << std::endl;
-#else
-  std::cout << "DepthOfRefViewsAvailFlag:" << depthOfRefViewsAvailFlag << std::endl;
-  std::cout << "TextOfCurViewAvailFlag  :" << textOfCurViewAvailFlag   << std::endl;
-#endif
   
   std::cout << "ivMvPredFlag            :" << m_ivMvPredFlag           << std::endl;
@@ -4345,13 +4191,91 @@
   std::cout << "qtPredFlag              :" << m_qtPredFlag             << std::endl;
   std::cout << "interSdcFlag            :" << m_interSdcFlag           << std::endl;
-#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
   std::cout << "depthIntraSkipFlag      :" << m_depthIntraSkipFlag     << std::endl;    
-#else
-  std::cout << "intraSingleFlag         :" << m_intraSingleFlag        << std::endl;    
-#endif
   std::cout << "subPbSize               :" << m_subPbSize              << std::endl;
   std::cout << "mpiSubPbSize            :" << m_mpiSubPbSize           << std::endl;
 #endif
 }
+
+Void TComSlice::deriveInCmpPredAndCpAvailFlag()
+{
+  Int numCurCmpLIds = getIsDepth() ? 1 : getNumActiveRefLayerPics(); 
+  std::vector<Int> curCmpLIds;
+  if ( getIsDepth() )
+  {
+    curCmpLIds.push_back( getLayerId() );
+  }
+  else
+  {
+    for (Int i = 0; i < numCurCmpLIds; i++)
+    {
+      curCmpLIds.push_back( getRefPicLayerId( i ) );
+    }
+  }
+
+  m_cpAvailableFlag = true;
+  m_inCmpRefViewIdcs.clear();
+  Bool allRefCmpLayersAvailFlag = true;
+
+  for( Int i = 0; i <= numCurCmpLIds - 1; i++ )
+  {      
+    m_inCmpRefViewIdcs.push_back( getVPS()->getViewOrderIdx( curCmpLIds[ i ] ));
+    if( !getVPS()->getCpPresentFlag( getVPS()->getVoiInVps( getViewIndex() ),  getVPS()->getVoiInVps( m_inCmpRefViewIdcs[ i ] ) ) )
+    {
+      m_cpAvailableFlag = false;
+    }
+    Bool refCmpCurLIdAvailFlag = false;
+    if( getVPS()->getViewCompLayerPresentFlag( m_inCmpRefViewIdcs[ i ], !getIsDepth() ) )
+    {
+      Int j = getVPS()->getLayerIdInVps( getVPS()->getViewCompLayerId( m_inCmpRefViewIdcs[ i ],  !getIsDepth() ) );
+      if  ( getVPS()->getDirectDependencyFlag( getVPS()->getLayerIdInVps( getLayerId() ) ,  j ) &&
+        getVPS()->getSubLayersVpsMaxMinus1( j ) >= getTemporalId()   &&
+        ( getTemporalId() == 0 || getVPS()->getMaxTidIlRefPicsPlus1( j , getVPS()->getLayerIdInVps( getLayerId() ) ) > getTemporalId() )        
+        )
+      {
+        refCmpCurLIdAvailFlag = true;
+      }
+    }
+    if( !refCmpCurLIdAvailFlag )
+    {
+      allRefCmpLayersAvailFlag = false;
+    }
+  }
+
+  if( !allRefCmpLayersAvailFlag )
+  {
+    m_inCmpPredAvailFlag = false;
+  }  
+  else 
+  {
+    TComSps3dExtension* sps3dExt = getSPS()->getSps3dExtension();
+    if( !getIsDepth() )
+    {
+      m_inCmpPredAvailFlag = sps3dExt->getViewSynthesisPredFlag( getIsDepth() ) || 
+        sps3dExt->getDepthBasedBlkPartFlag( getIsDepth() ) || 
+        sps3dExt->getDepthRefinementFlag  ( getIsDepth() );                            
+    }
+    else
+    {
+      m_inCmpPredAvailFlag = sps3dExt->getIntraContourFlag( getIsDepth() ) || 
+        sps3dExt->getQtPredFlag( getIsDepth() ) || 
+        sps3dExt->getMpiFlag( getIsDepth() );                                  
+    }
+  }
+}
+
+Void TComSlice::checkInCompPredRefLayers()
+{
+  if ( getInCompPredFlag() )
+  {
+    for (Int i = 0; i < getNumCurCmpLIds(); i++ )
+    {
+      assert( getIvPic(!getIsDepth(), getInCmpRefViewIdcs( i ) ) != NULL );       
+      //  It is a requirement of bitstream conformance that there 
+      //  is a picture in the DPB with PicOrderCntVal equal to the PicOrderCntVal of the current picture, 
+      //  and a nuh_layer_id value equal to ViewCompLayerId[ inCmpRefViewIdcs[ i ] ][ !DepthFlag ].
+    }
+  }
+}
+
 #endif
 
